//ASMXFIVP JOB (001),'ASM XF IVP',                                      00010000
//             MSGLEVEL=1,CLASS=A,MSGCLASS=A,REGION=256K                00020000
//ASM  EXEC  ASMCG,APGM='IFOX00',APRM='LIST,OBJECT,NODECK',             00030000
//           ASOT='A',GSOT='A'                                          00040000
//ASM.SYSIN  DD  *                                                      00050000
EXAM     TITLE 'SAMPLE PROGRAM'                                         00060000
         PRINT DATA                                                     00070000
*                                                                       00080000
*        THIS IS THE MACRO DEFINITION                                   00090000
*                                                                       00100000
         MACRO                                                          00110000
         MOVE  &TO,&FROM                                                00120000
.*                                                                      00130000
.*       DEFINE SETC SYMBOL                                             00140000
.*                                                                      00150000
         LCLC  &TYPE                                                    00160000
.*                                                                      00170000
.*       CHECK NUMBER OF OPERANDS                                       00180000
.*                                                                      00190000
         AIF   (N'&SYSLIST NE 2).ERROR1                                 00200000
.*                                                                      00210000
.*       CHECK TYPE ATTRIBUTES OF OPERANDS                              00220000
.*                                                                      00230000
         AIF   (T'&TO NE T'&FROM).ERROR2                                00240000
         AIF   (T'&TO EQ 'C' OR T'&TO EQ 'G' OR T'&TO EQ 'K').TYPECGK   00250000
         AIF   (T'&TO EQ 'D' OR T'&TO EQ 'E' OR T'&TO EQ 'H').TYPEDEH   00260000
         AIF   (T'&TO EQ 'F').MOVE                                      00270000
         AGO   .ERROR3                                                  00280000
.TYPEDEH ANOP                                                           00290000
.*                                                                      00300000
.*       ASSIGN TYPE ATTRIBUTE TO SETC SYMBOL                           00310000
.*                                                                      00320000
&TYPE    SETC  T'&TO                                                    00330000
.MOVE    ANOP                                                           00340000
*        NEXT TWO STATEMENTS GENERATED FOR MOVE MACRO                   00350000
         L&TYPE   2,&FROM                                               00360000
         ST&TYPE  2,&TO                                                 00370000
         MEXIT                                                          00380000
.*                                                                      00390000
.*       CHECK LENGTH ATTRIBUTES OF OPERANDS                            00400000
.*                                                                      00410000
.TYPECGK AIF   (L'&TO NE L'&FROM OR L'&TO GT 256).ERROR4                00420000
*        NEXT STATEMENT GENERATED FOR MOVE MACRO                        00430000
         MVC   &TO,&FROM                                                00440000
         MEXIT                                                          00450000
.*                                                                      00460000
.*       ERROR MESSAGES FOR INVALID MOVE MACRO INSTRUCTIONS             00470000
.*                                                                      00480000
.ERROR1  MNOTE 1,'IMPROPER NUMBER OF OPERANDS, NO STATEMENTS GENERATED' 00490000
         MEXIT                                                          00500000
.ERROR2  MNOTE 1,'OPERAND TYPES DIFFERENT, NO STATEMENTS GENERATED'     00510000
         MEXIT                                                          00520000
.ERROR3  MNOTE 1,'IMPROPER OPERAND TYPES, NO STATEMENTS GENERATED'      00530000
         MEXIT                                                          00540000
.ERROR4  MNOTE 1,'IMPROPER OPERAND LENGTHS, NO STATEMENTS GENERATED'    00550000
         MEND                                                           00560000
*                                                                       00570000
*        MAIN ROUTINE                                                   00580000
*                                                                       00590000
SAMPLR   CSECT                                                          00600000
BEGIN    SAVE  (14,12),,*                                               00610000
         BALR  R12,0         ESTABLISH ADDRESSABILITY OF PROGRAM        00620000
         USING *,R12         AND TELL THE ASSEMBLER WHAT BASE TO USE    00630000
         ST    13,SAVE13                                                00640000
         LM    R5,R7,=A(LISTAREA,16,LISTEND)  LOAD LIST AREA PARAMETERS 00650000
         USING LIST,R5      REGISTER 5 POINTS TO THE LIST               00660000
MORE     BAL   R14,SEARCH   FIND LIST ENTRY IN TABLE                    00670000
         TM    SWITCH,NONE  CHECK TO SEE IF NAME WAS FOUND              00680000
         BO    NOTTHERE     BRANCH IF NOT                               00690000
         USING TABLE,R1     REGISTER 1 NOW POINTS TO TABLE ENTRY        00700000
         MOVE  TSWITCH,LSWITCH          MOVE FUNCTIONS                  00710000
         MOVE  TNUMBER,LNUMBER               FROM LIST ENTRY            00720000
         MOVE  TADDRESS,LADDRESS                  TO TABLE ENTRY        00730000
LISTLOOP BXLE  R5,R6,MORE   LOOP THROUGH THE LIST                       00740000
         CLC   TESTTABL(240),TABLAREA                                   00750000
         BNE   NOTRIGHT                                                 00760000
         CLC   TESTLIST(96),LISTAREA                                    00770000
         BNE   NOTRIGHT                                                 00780000
         WTO   'ASSEMBLER SAMPLE PROGRAM SUCCESSFUL'                    00790000
         WTO '********************************************************' 00800000
         WTO '* PLEASE PROVIDE A CARD COPY OF THE STAGE I INPUT DECK *' 00810000
         WTO '* USE THE IBM SUPPLIED LABELS/ENVELOPES FOR MAILING    *' 00820000
         WTO '********************************************************' 00830000
EXIT     L     R13,SAVE13                                               00840000
         RETURN (14,12),RC=0                                            00850000
*                                                                       00860000
NOTRIGHT WTO   'ASSEMBLER SAMPLE PROGRAM UNSUCCESSFUL'                  00870000
         WTO '********************************************************' 00880000
         WTO '* PLEASE PROVIDE A CARD COPY OF THE STAGE I INPUT DECK *' 00890000
         WTO '* USE THE IBM SUPPLIED LABELS/ENVELOPES FOR MAILING    *' 00900000
         WTO '********************************************************' 00910000
         B     EXIT                                                     00920000
NOTTHERE OI    LSWITCH,NONE TURN ON SWITCH IN LIST ENTRY                00930000
         B     LISTLOOP     GO BACK AND LOOP                            00940000
SAVE13   DC    F'0'                                                     00950000
SWITCH   DC    X'00'                                                    00960000
NONE     EQU   X'80'                                                    00970000
*                                                                       00980000
*        BINARY SEARCH ROUTINE                                          00990000
*                                                                       01000000
SEARCH   NI    SWITCH,255-NONE TURN OFF NOT FOUND SWITCH                01010000
         LM    R1,R3,=F'128,4,128' LOAD TABLE PARAMETERS                01020000
         LA    R1,TABLAREA-16(R1)  GET ADDRESS OF MIDDLE ENTRY          01030000
LOOP     SRL   R3,1                DIVIDE INCREMENT BY 2                01040000
         CLC   LNAME,TNAME         COMPARE LIST ENTRY WITH TABLE ENTRY  01050000
         BH    HIGHER              BRANCH IF SHOULD BE HIGHER IN TABLE  01060000
         BCR   8,R14               EXIT IF FOUND                        01070000
         SR    R1,R3               OTHERWISE IT IS LOWER IN THE TABLE  X01080000
                                     SO SUBTRACT INCREMENT              01090000
         BCT   R2,LOOP             LOOP 4 TIMES                         01100000
         B     NOTFOUND            ARGUMENT IS NOT IN THE TABLE         01110000
HIGHER   AR    R1,R3               ADD INCREMENT                        01120000
         BCT   R2,LOOP             LOOP 4 TIMES                         01130000
NOTFOUND OI    SWITCH,NONE         TURN ON NOT FOUND SWITCH             01140000
         BR    R14                 EXIT                                 01150000
*                                                                       01160000
*        THIS IS THE TABLE                                              01170000
*                                                                       01180000
         DS    0D                                                       01190000
TABLAREA DC    XL8'0',CL8'ALPHA'                                        01200000
         DC    XL8'0',CL8'BETA'                                         01210000
         DC    XL8'0',CL8'DELTA'                                        01220000
         DC    XL8'0',CL8'EPSILON'                                      01230000
         DC    XL8'0',CL8'ETA'                                          01240000
         DC    XL8'0',CL8'GAMMA'                                        01250000
         DC    XL8'0',CL8'IOTA'                                         01260000
         DC    XL8'0',CL8'KAPPA'                                        01270000
         DC    XL8'0',CL8'LAMBDA'                                       01280000
         DC    XL8'0',CL8'MU'                                           01290000
         DC    XL8'0',CL8'NU'                                           01300000
         DC    XL8'0',CL8'OMICRON'                                      01310000
         DC    XL8'0',CL8'PHI'                                          01320000
         DC    XL8'0',CL8'SIGMA'                                        01330000
         DC    XL8'0',CL8'ZETA'                                         01340000
*                                                                       01350000
*        THIS IS THE LIST                                               01360000
*                                                                       01370000
LISTAREA DC    CL8'LAMBDA',X'0A',FL3'29',A(BEGIN)                       01380000
         DC    CL8'ZETA',X'05',FL3'5',A(LOOP)                           01390000
         DC    CL8'THETA',X'02',FL3'45',A(BEGIN)                        01400000
         DC    CL8'TAU',X'00',FL3'0',A(1)                               01410000
         DC    CL8'LIST',X'1F',FL3'465',A(0)                            01420000
LISTEND  DC    CL8'ALPHA',X'00',FL3'1',A(123)                           01430000
*                                                                       01440000
*        THIS IS THE CONTROL TABLE                                      01450000
*                                                                       01460000
         DS    0D                                                       01470000
TESTTABL DC    FL3'1',X'00',A(123),CL8'ALPHA'                           01480000
         DC    XL8'0',CL8'BETA'                                         01490000
         DC    XL8'0',CL8'DELTA'                                        01500000
         DC    XL8'0',CL8'EPSILON'                                      01510000
         DC    XL8'0',CL8'ETA'                                          01520000
         DC    XL8'0',CL8'GAMMA'                                        01530000
         DC    XL8'0',CL8'IOTA'                                         01540000
         DC    XL8'0',CL8'KAPPA'                                        01550000
         DC    FL3'29',X'0A',A(BEGIN),CL8'LAMBDA'                       01560000
         DC    XL8'0',CL8'MU'                                           01570000
         DC    XL8'0',CL8'NU'                                           01580000
         DC    XL8'0',CL8'OMICRON'                                      01590000
         DC    XL8'0',CL8'PHI'                                          01600000
         DC    XL8'0',CL8'SIGMA'                                        01610000
         DC    FL3'5',X'05',A(LOOP),CL8'ZETA'                           01620000
*                                                                       01630000
*        THIS IS THE CONTROL LIST                                       01640000
*                                                                       01650000
TESTLIST DC    CL8'LAMBDA',X'0A',FL3'29',A(BEGIN)                       01660000
         DC    CL8'ZETA',X'05',FL3'5',A(LOOP)                           01670000
         DC    CL8'THETA',X'82',FL3'45',A(BEGIN)                        01680000
         DC    CL8'TAU',X'80',FL3'0',A(1)                               01690000
         DC    CL8'LIST',X'9F',FL3'465',A(0)                            01700000
         DC    CL8'ALPHA',X'00',FL3'1',A(123)                           01710000
*                                                                       01720000
*        THESE ARE THE SYMBOLIC REGISTERS                               01730000
*                                                                       01740000
R0       EQU   0                                                        01750000
R1       EQU   1                                                        01760000
R2       EQU   2                                                        01770000
R3       EQU   3                                                        01780000
R5       EQU   5                                                        01790000
R6       EQU   6                                                        01800000
R7       EQU   7                                                        01810000
R12      EQU   12                                                       01820000
R13      EQU   13                                                       01830000
R14      EQU   14                                                       01840000
R15      EQU   15                                                       01850000
*                                                                       01860000
*        THIS IS THE FORMAT DEFINITION OF LIST ENTRYS                   01870000
*                                                                       01880000
LIST     DSECT                                                          01890000
LNAME    DS    CL8                                                      01900000
LSWITCH  DS    C                                                        01910000
LNUMBER  DS    FL3                                                      01920000
LADDRESS DS    F                                                        01930000
*                                                                       01940000
*        THIS IS THE FORMAT DEFINITION OF TABLE ENTRYS                  01950000
*                                                                       01960000
TABLE    DSECT                                                          01970000
TNUMBER  DS    FL3                                                      01980000
TSWITCH  DS    C                                                        01990000
TADDRESS DS    F                                                        02000000
TNAME    DS    CL8                                                      02010000
         END   BEGIN                                                    02020000
//                                                                      02030000
